
/* Chrysalide - Outil d'analyse de fichiers binaires
 * node-int.h - prototypes internes pour la décomposition d'un motif de recherche en atomes assemblés
 *
 * Copyright (C) 2023 Cyrille Bagard
 *
 *  This file is part of Chrysalide.
 *
 *  Chrysalide is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Chrysalide is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with Foobar.  If not, see <http://www.gnu.org/licenses/>.
 */


#ifndef _ANALYSIS_SCAN_PATTERNS_TOKENS_NODE_INT_H
#define _ANALYSIS_SCAN_PATTERNS_TOKENS_NODE_INT_H


#include "node.h"



/* Inscrit la définition d'un motif dans un moteur de recherche. */
typedef bool (* enroll_scan_token_node_fc) (GScanTokenNode *, GScanContext *, GEngineBackend *, size_t);

/* Transforme les correspondances locales en trouvailles. */
typedef void (* check_scan_token_node_fc) (const GScanTokenNode *, GScanContext *, GBinContent *, pending_matches_t *, const node_search_offset_t *);


/* Décomposition d'un motif de recherche en atomes (instance) */
struct _GScanTokenNode
{
    GObject parent;                         /* A laisser en premier        */

};

/* Décomposition d'un motif de recherche en atomes (classe) */
struct _GScanTokenNodeClass
{
    GObjectClass parent;                    /* A laisser en premier        */

    enroll_scan_token_node_fc enroll;       /* Inscription d'un motif      */
    check_scan_token_node_fc check;         /* Conversion en trouvailles   */

};



#endif  /* _ANALYSIS_SCAN_PATTERNS_TOKENS_NODE_INT_H */
